Bug 1198760 - (mitmproxy) Review Request: mitmproxy - An interactive SSL-capable intercepting HTTP proxy [NEEDINFO]
Review Request: mitmproxy - An interactive SSL-capable intercepting HTTP proxy
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michal Ambroz
Fedora Extras Quality Assurance
:
: python-mitmproxy (view as bug list)
Depends On: 1236249 1249010
Blocks: FE-SECLAB
  Show dependency treegraph
 
Reported: 2015-03-04 14:03 EST by Fabian Affolter
Modified: 2017-12-30 06:51 EST (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rebus: fedora‑review?
rebus: needinfo? (mail)


Attachments (Terms of Use)

  None (edit)
Description Fabian Affolter 2015-03-04 14:03:32 EST
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy-0.11.3-1.fc21.src.rpm

Project URL: http://mitmproxy.org/

Description:
mitmproxy is an interactive, SSL-capable man-in-the-middle proxy for HTTP with
a console interface.

mitmdump is the command-line version of mitmproxy. Think tcpdump for HTTP.

libmproxy is the library that mitmproxy and mitmdump are built on.

Koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=9138575

rpmlint output:
[fab@laptop017 SRPMS]$ rpmlint mitmproxy-0.11.3-1.fc21.src.rpm 
mitmproxy.src: W: spelling-error %description -l en_US mitmdump -> dumdum
mitmproxy.src: W: spelling-error %description -l en_US tcpdump -> Dumpster
mitmproxy.src: W: spelling-error %description -l en_US libmproxy -> improbably
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

[fab@laptop017 noarch]$ rpmlint mitmproxy-0.11.3-1.fc21.noarch.rpm 
mitmproxy.noarch: W: spelling-error %description -l en_US tcpdump -> Dumpster
mitmproxy.noarch: W: no-manual-page-for-binary mitmproxy
mitmproxy.noarch: W: no-manual-page-for-binary mitmdump
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

Fedora Account System Username: fab
Comment 1 Fabian Affolter 2015-03-04 14:04:11 EST
*** Bug 1070418 has been marked as a duplicate of this bug. ***
Comment 2 Fabian Affolter 2015-06-04 05:34:24 EDT
%changelog
* Wed Jun 03 2015 Fabian Affolter <mail@fabian-affolter.ch> - 0.12.1-1
- Update to latest upstream release 0.12.1

Updated files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy-0.12.1-1.fc21.src.rpm
Comment 3 Michal Ambroz 2015-06-25 22:42:53 EDT
Hello Fabian,
any reason why the source is taken from 3rd party (pypi.python.org) and not from the release on the pages (https://mitmproxy.org/download/mitmproxy-0.12.1.tar.gz) or directly from their github (https://github.com/mitmproxy/mitmproxy/archive/946fd375fa87fb8a4d071a354fb99840b0ccfdf3/mitmproxy-0.12.1-946fd375.tar.gz)

Personally I would recommend taking directly from github:
https://github.com/mitmproxy/mitmproxy/releases

%global         gituser         mitmproxy
%global         gitname         mitmproxy
%global         commit          946fd375fa87fb8a4d071a354fb99840b0ccfdf3
%global         shortcommit     %(c=%{commit}; echo ${c:0:7})


Source0:        https://github.com/%{gituser}/%{gitname}/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz

%setup -qn %{gitname}-%{commit}

Best regards
Michal Ambroz
Comment 4 Fabian Affolter 2015-06-26 08:10:02 EDT
(In reply to Michal Ambroz from comment #3)
> any reason why the source is taken from 3rd party (pypi.python.org)

No reason. I will go with the tarball from the upstream website. At the moment from my point of view there is no meed to run with the git source.

Anyway, thanks for the input.

Updated files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy-0.12.1-2.fc22.src.rpm
Comment 5 Michal Ambroz 2015-06-26 20:20:23 EDT
Hello,
generaly most of the checks are OK.
I have identified these issues:
1) Licenses/budled libraries
Package contains bundled libraries. I believe that html2text is problem even from the licensing point of view.
My recommendation is to:
- unbundle html2text and pyparsig - which already have separate package
- agree with bluefish maintainer on unbundling js-beautify/jsbeautifier
- tneststring and wbxml - it would be probably best to ask mitmproxy author on what would be the effort needed to unbundle those

2) Source checksums
- when checking the MD5 I have noticed that source on github and upstream website are different. Packages seems to be same, but probably repacked on different platform.
- Please can you inform the upstream about this issue?

3) Man pages
- this falls to the "should" not must category so it would not be blocking the package approval.
- Please any chance getting the man-pages from the Debian package and try to push it upstream?

Best regards
Michal Ambroz


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
	- MIT
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 114 files have
     unknown license.
	- BSD - for example libmproxy/web/static/vendor.js
	- GPLv3 - libmproxy/contrib/html2text.py

[!]: Package contains no bundled libraries without FPC exception.
- pyparsing /usr/lib/python2.7/site-packages/libmproxy/contrib/pyparsing.py - there is already package pyparsing
- GPLv3 - libmproxy/contrib/html2text.py - https://github.com/aaronsw/html2text - there is already package python-html2text
- MITM - jsbeautifier - https://github.com/beautify-web/js-beautify - part of bluefish-shared-data package (probably issue there as well)
- libmproxy/tnetstring.py - https://github.com/rfk/tnetstring
- wbxml - libmproxy/contrib/wbxml - https://github.com/davidpshaw/PyWBXMLDecoder

[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 25 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
     - changing shebang in some python scripts is changing timestamp, but
     those files are really changed so I guess that is fine

[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     - false positive spelling errors - can be ignored
     - man pages - ay chance to take manpages from Debian package and ask upstream to add those?
[x]: Spec file according to URL is the same as in SRPM.



Rpmlint
-------
Checking: mitmproxy-0.12.1-1.fc21.noarch.rpm
          mitmproxy-0.12.1-1.fc21.src.rpm
mitmproxy.noarch: W: spelling-error %description -l en_US tcpdump -> Dumpster
mitmproxy.noarch: W: no-manual-page-for-binary mitmproxy
mitmproxy.noarch: W: no-manual-page-for-binary mitmweb
mitmproxy.noarch: W: no-manual-page-for-binary mitmdump
mitmproxy.src: W: spelling-error %description -l en_US mitmdump -> dumdum
mitmproxy.src: W: spelling-error %description -l en_US tcpdump -> Dumpster
mitmproxy.src: W: spelling-error %description -l en_US libmproxy -> improbably
2 packages and 0 specfiles checked; 0 errors, 7 warnings.




Requires
--------
mitmproxy (rpmlib, GLIBC filtered):
    /usr/bin/python2
    protobuf
    pyamf
    pyasn1
    python(abi)
    python-cssutils
    python-flask
    python-urwid



Provides
--------
mitmproxy:
    mitmproxy



Source checksums
----------------
http://pypi.python.org/packages/source/m/mitmproxy/mitmproxy-0.12.1.tar.gz :
  CHECKSUM(SHA256) this package     : a7a59faa1f79a97c5cbd7acdaca72cfbf9903b9e39823226bc5d8a30efc07e70
  CHECKSUM(SHA256) upstream package : a7a59faa1f79a97c5cbd7acdaca72cfbf9903b9e39823226bc5d8a30efc07e70
Comment 6 Michal Ambroz 2015-07-09 14:52:37 EDT
Ping?
Comment 7 Fabian Affolter 2015-07-27 15:05:58 EDT
Thanks for all your work. I'm a bit busy right now but I will work on this as soon as possible.
Comment 8 Michal Ambroz 2015-07-31 06:36:06 EDT
js-beautify code is currently packaged in nodejs-js-beautify, but the package doesn't provide currently the python bindings. I created bug 1249010 for that.
Comment 9 Michal Ambroz 2015-10-11 21:53:40 EDT
Ping?
Comment 10 Fabian Affolter 2015-10-30 08:49:11 EDT
Still shipping the third-party stuff...

%changelog
* Fri Oct 30 2015 Fabian Affolter <mail@fabian-affolter.ch> - 0.13-1
- Update macros
- Update to latest upstream release 0.13

Updated files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy-0.13-1.fc22.src.rpm
Comment 11 Dusty Mabe 2016-01-08 11:56:39 EST
+1 Would love to have this packaged.
Comment 12 Fabian Affolter 2016-03-22 14:04:09 EDT
Just update for the latest release.

%changelog
* Sun Jan 24 2016 Fabian Affolter <mail@fabian-affolter.ch> - 0.15-1
- Update to latest upstream release 0.15

Updated files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/mitmproxy-0.15-1.fc23.src.rpm
Comment 13 Alex 2016-04-17 13:09:07 EDT
One of the install-time dependencies for the built package is 'pyamf', but this doesn't seem to be available in any F23 repo I can find.. any clues?

Thanks
Comment 14 Michal Ambroz 2016-11-21 08:09:22 EST
Latest version is 0.18.2
Pyamf package still not available in Fedora
Comment 15 Andrea Musuruane 2017-12-30 06:51:03 EST
Latest version is 2.0.2.

Pyamf support is optional:
https://github.com/mitmproxy/mitmproxy/pull/62

Note You need to log in before you can comment on or make changes to this bug.